/* IMPLEMENTATION ARI... VERSION 0.0 OF 26.5.97 BY WH, WU-WIEN & BU-ISTANBUL*/
/* this file:   ari.h */
#include <math.h>
#include <stdio.h>
#include <malloc.h>

void *arisetup(/*hh,param,m,la,ra,pma*/);
/*set-up: Function computes all constants necessary for generation
  hh.. pointer to function returning the probabilities, 
  param.. parameters of distribution,
  m .. mode, la .. left border of domain, ra .. right border of domain
  pma .. approximate probability of mode*/

long int arisample(/*t*/);
/*samples from the discrete distribution using the constants computed
  in the set up; t... pointer pointing to these constants*/

void prariopt();
/* utility printing the actual values of the macro-parameters*/

/*this is the structur for the parameters of the discrete distributions*/
typedef struct { double d1, d2, d3, d4;
                 long i1,i2,i3;   
	       }PARAM;
#define NULL 0 /*this should be the NULL-pointer*/

/* this are macro-parameters of the algorithm which can be changed by the 
   user before compilation:*/
#define C_ARI 1  /*default 1..T=-1/sqrt(x), 0..T=log(x),2 ... T=-x^c */
#define C1_ARI -0.34 /*value of the c for the transform T if C_ARI==2*/
#define N_ARI 1000 /*size of auxiliary array, default 1000, must be >=1*/
#define CHECK_ARI 0 /*default 0...no checking,1... correctness of hat checked*/
#define EPS_CHECK_ARI 1.e-8 /* default 1.e-8 tolerance for error of hat fit*/
#define SQUEEZE_ARI 0 /*default 0...without squeeze,1...with squeeze*/
#define UNIFORM_ARI uniform() /* uniform U(0,1)random number generator*/











